
{*******************************************************************************
                     Digital Avto Tuning

                   http://valery-us4leh.narod.ru
                US4LEH    zima31@Kharkov.com   2004

*******************************************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, LPTIO,
  ExtCtrls, StdCtrls, ComCtrls, Gauges, Spin, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    TrackBar1: TTrackBar;
    GroupBox2: TGroupBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Gauge1: TGauge;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RichEdit1: TRichEdit;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Timer1: TTimer;
    CheckBox2: TCheckBox;
    Timer2: TTimer;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Timer3: TTimer;
    SpeedButton5: TSpeedButton;
    Edit2: TEdit;
    Timer4: TTimer;
    Label7: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);

  private
    { Private declarations }
    Lpt : TLptPortConnection;
  public
    { Public declarations }
    function GetCurrentPort : byte;     //   ComboBox1     
 // function GetCurrentRegister : byte; //   ComboBox2     



 //*********************PIN**************************************************
     function Pin2 : boolean;
     function Pin3 : boolean ;
     function Pin4 : boolean ;
     function Pin5 : boolean ;
     function Pin6 : boolean ;
     function Pin7 : boolean ;
     function Pin8 : boolean ;
     function Pin9 : boolean ;

     function Pin1 : boolean ;
     function Pin14 : boolean ;
     function Pin16 : boolean ;
     function Pin17 : boolean ;

     function Pin11 : boolean ;
     function Pin10 : boolean ;
     function Pin12 : boolean ;
     function Pin13 : boolean ;
     function Pin15 : boolean ;
   //**************************************************************************

   {------------  Pin -------------------------------}

     procedure ButtonPin2;
     procedure ButtonPin3;
     procedure ButtonPin4;
     procedure ButtonPin5;
     procedure ButtonPin6;
     procedure ButtonPin7;
     procedure ButtonPin8;
     procedure ButtonPin9;

     procedure ButtonPin1;
     procedure ButtonPin14;
     procedure ButtonPin16;
     procedure ButtonPin17;

   //*************************************************************************

  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var msg : AnsiString;
begin
 Lpt := TLptPortConnection.Create;
 if not Lpt.Ready then
  begin {    --    }
  msg := '    Lpt,   ERROR,   = ' + IntToStr(GetLastError());
  Application.MessageBox(PChar(msg),'ERROR',MB_OK);
  Application.Terminate; // 
  end;
 //         ComboBox-e
 ComboBox1.Items.Clear;
 ComboBox1.Text := '';
 if Lpt.IsPortPresent(LPT1) then ComboBox1.Items.Add('$3BC');
 if Lpt.IsPortPresent(LPT2) then ComboBox1.Items.Add('$378'); //-: $378   LPT2! 
 if Lpt.IsPortPresent(LPT3) then ComboBox1.Items.Add('$278');

 if 0<>ComboBox1.Items.Count then ComboBox1.ItemIndex := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject); //  
begin
 Lpt.Destroy;
 Timer1.Enabled := false;
 Timer2.Enabled := false;
 Timer3.Enabled := false;
{    ,    }
end;




function TForm1.GetCurrentPort : byte;     //   ComboBox1     
begin
 if '$3BC' = ComboBox1.Text then
  GetCurrentPort:=LPT1
                            else
  if '$378' = ComboBox1.Text then
   GetCurrentPort:=LPT2      else
   GetCurrentPort:=LPT3;
end;


 //-------  ------------
{
function TForm1.GetCurrentRegister : byte; //   ComboBox2     
begin
 if '' = ComboBox2.Text then
  GetCurrentRegister:=LPT_DATA_REG
                              else
  if '' = ComboBox2.Text       then
   GetCurrentRegister:=LPT_STATE_REG    else
   GetCurrentRegister:=LPT_CONTROL_REG;
end;
      }

//***********  - PIN - *******************************************

      
 function TForm1.Pin2 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (1 = (1 and Lpt.ReadPort( (GetCurrentPort) ,0))) ;
     Pin2 := d;
 end;

 function TForm1.Pin3 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (2 = (2 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin3 := d;
 end;

 function TForm1.Pin4 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (4 = (4 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin4 := d;
 end;

 function TForm1.Pin5 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (8 = (8 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin5 := d;
 end;

 function TForm1.Pin6 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (16 = (16 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin6 := d;
 end;

 function TForm1.Pin7 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (32 = (32 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin7 := d;
 end;

 function TForm1.Pin8 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (64 = (64 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin8 := d;
 end;

 function TForm1.Pin9 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (128 = (128 and Lpt.ReadPort(GetCurrentPort,0))) ;
     Pin9 := d;
 end;
//-------------------------------------------------------

 
 function TForm1.Pin1 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor (STROBE  = (STROBE  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin1 := d;
 end;
 
 function TForm1.Pin14 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor (AUTOFEED  = (AUTOFEED  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin14 := d;
 end;
 
 function TForm1.Pin16 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and (INIT  = (INIT  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin16 := d;
 end;
 
 function TForm1.Pin17 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor (SELECTIN  = (SELECTIN  and Lpt.ReadPort(GetCurrentPort,2))) ;
     Pin17 := d;
 end;

 //--------------------------------------------------------
 function TForm1.Pin11 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d xor(BUSY = (BUSY and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin11 := d;
 end;

  function TForm1.Pin10 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(ACK  = (ACK  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin10 := d;
 end;

 function TForm1.Pin12 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(PAPEREND  = (PAPEREND  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin12 := d;
 end;

 function TForm1.Pin13 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(SELECT = (SELECT  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin13 := d;
 end;

 function TForm1.Pin15 : boolean ;
 Var
 d : boolean;
 begin
     d := true;
     d := d and(ERROR  = (ERROR  and Lpt.ReadPort(GetCurrentPort,1))) ;
     Pin15 := d;
 end;     

//******************************************************************************
{----------------------- Pin ---------------------------------}

 procedure TForm1.ButtonPin2;
 begin
 Lpt.WritePort (GetCurrentPort,0,(1 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;

 procedure TForm1.ButtonPin3;
 begin
 Lpt.WritePort (GetCurrentPort,0,(2 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;

 procedure TForm1.ButtonPin4;
 begin
 Lpt.WritePort (GetCurrentPort,0,(4 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;

 procedure TForm1.ButtonPin5;
 begin
 Lpt.WritePort (GetCurrentPort,0,(8 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;
 
 procedure TForm1.ButtonPin6;
 begin
 Lpt.WritePort (GetCurrentPort,0,(16 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;
 
 procedure TForm1.ButtonPin7;
 begin
 Lpt.WritePort (GetCurrentPort,0,(32 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;
 
 procedure TForm1.ButtonPin8;
 begin
 Lpt.WritePort (GetCurrentPort,0,(64 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;
 
 procedure TForm1.ButtonPin9;
 begin
 Lpt.WritePort (GetCurrentPort,0,(128 xor Lpt.ReadPort( (GetCurrentPort) ,0) ));
 end;


 { -------------------    ------------------------------ }

 procedure TForm1.ButtonPin1;
 begin
 Lpt.WritePort (GetCurrentPort,2,(1 xor Lpt.ReadPort( (GetCurrentPort) ,2) ));
 end;
 
 procedure TForm1.ButtonPin14;
 begin
 Lpt.WritePort (GetCurrentPort,2,(2 xor Lpt.ReadPort( (GetCurrentPort) ,2) ));
 end;

 procedure TForm1.ButtonPin16;
 begin
 Lpt.WritePort (GetCurrentPort,2,(4 xor Lpt.ReadPort( (GetCurrentPort) ,2) ));
 end;

 procedure TForm1.ButtonPin17;
 begin
 Lpt.WritePort (GetCurrentPort,2,(8 xor Lpt.ReadPort( (GetCurrentPort) ,2) ));
 end;

 //*****  .     ,     ! ******
  
{-------  XP: lptwdmio.sys      ------------- }
{---------------------------- -------------------------------------------}



procedure TForm1.SpinEdit1Change(Sender: TObject); //--   SpinEdit1 :
begin
 TrackBar1.Position := SpinEdit1.Value; //--  TrackBar1  SpinEdit1
 Lpt.WritePort (GetCurrentPort,0,SpinEdit1.Value); //--    . 
 {      }
 if SpinEdit1.Tag = 0 then
 begin
 Edit1.Text := IntToStr(SpinEdit1.Value); //--  
 SpinEdit1.Tag := 1;
 end;
 
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
SpinEdit1.Value := TrackBar1.Position; //-- 
if CheckBox2.Checked = true then //--   LOG
RichEdit1.Lines.Add //--  
( FormatDateTime('hh:mm:ss', time()) + '    ' + IntToStr(SpinEdit1.Value)
+'  '+ '' + Edit2.Text ); //-- +  + 

end;

 procedure TForm1.Timer1Timer(Sender: TObject); //--   
 Var
 b : byte;
 begin
  b:= Lpt.ReadPort (GetCurrentPort,0); //--    - 0
  Label2.Caption := '.   :  '+ IntToStr(b);  //--   
 
  SpeedButton1.Enabled := not Pin10; //--   . 0  Pin10
  SpeedButton2.Enabled := not Pin11; //--   . 0  Pin11
 end;

procedure TForm1.Timer2Timer(Sender: TObject); //--   
begin
if CheckBox1.Checked = true then //--   "" :
begin {  -   -,   . }
 if (Pin11 = true)   and (Pin10 = true)  or  //--  Pin11 = 5  Pin10 = 5 
    (Pin11 = false)  and (Pin10 = false) then  //--  Pin11  = 5  Pin10  = 5 :
 SpeedButton3.Enabled := true else  //--    

 begin
 if RadioButton2.Checked = true then //--  . . 
 begin {   [    SpeedButton-] }
 SpeedButton3.Enabled := false; //--   
 if Pin11 = false then  //--   0  Pin11  + 1
 SpinEdit1.Value := SpinEdit1.Value +1 else //-- :
 if Pin10 = false then //--   0  Pin10  - 1
 SpinEdit1.Value := SpinEdit1.Value -1 ;
 end;
 end;

 if RadioButton1.Checked = true then //--  .  
 begin {  .    }

 if (Pin11 = false)  or (Pin10 = false)  then //--     11  10 
 Timer3.Enabled := true  else //--    , :
 Timer3.Tag := 0; //--          
 end;

 {  11  12  .   [   .] }
 if (Pin11 = false)   and (Pin10 = false) then //--  ()    
 SpeedButton4.Visible := true else //-- 
 SpeedButton4.Visible := false; //--  ()
 end;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
 Timer2.Interval := SpinEdit2.Value; //--  ()  
 Timer3.Interval := SpinEdit2.Value; //--  (  )  . 
end;

procedure TForm1.Timer3Timer(Sender: TObject); //--  . .   
begin
 if Timer3.Tag = 0 then  //--       
 begin
 SpeedButton3.Enabled := false; //--   
 if Pin11 = false then  //--   0  Pin11  + 1
 SpinEdit1.Value := SpinEdit1.Value +1 else //-- :
 if Pin10 = false then //--   0  Pin10  - 1
 SpinEdit1.Value := SpinEdit1.Value -1 ;
 Timer3.Tag := 1; //--   ,    
 end;
 Timer3.Enabled := false; //--       
end;

procedure TForm1.Timer4Timer(Sender: TObject); //--     
Var a,b,c : integer;
begin
 if CheckBox1.Checked = true then //--   
 begin
 a := StrToInt(Edit1.Text);  //-- 
 b := SpinEdit1.Value;  //-- 
 c := 0; //--   
 Gauge1.MaxValue := a; //--     %

 if SpinEdit1.Value < a then  //--   :
 begin
 c := a-b;  //--  
 Edit2.Text := '  - ' + IntToStr(c); //--  "-"  
 end;
 if SpinEdit1.Value = a then
 begin
 c := a-b; //-- 
 Edit2.Text := '    ' + IntToStr(c); //--  -  +
 end;
 if SpinEdit1.Value > a then
 begin
 c := b-a; //-- 
 Edit2.Text := '  + ' + IntToStr(c); //--  "+"  
 end;    

 Gauge1.Progress := c; //--  .   
 end;


end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked = true then
  SpinEdit1.Tag := 0;  //--   
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
Application.HintColor := cllime;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
 MessageBox(Handle,PChar( '     .   US4LEH  http://valery-us4leh.narod.ru ().  . '),
 PChar(' '),MB_ICONINFORMATION + MB_OK +MB_DEFBUTTON2);
end;

end.
